#!/usr/bin/env python
# -*- coding: utf-8 -*-

from models.conversation import Conversation
from models.event import Event
from flask_app import api
from flask_restplus import Resource, fields
from flask import request
from util.alchemy import db, engine
from sqlalchemy.orm.exc import NoResultFound
from sqlalchemy.exc import DataError
from flask_restplus.errors import abort
from sqlalchemy.orm import sessionmaker

nm_conversation = api.namespace(
    "conversation", description="A group of events")

conversation_api_model =  api.model('Conversation', {
        'id': fields.String(readonly=True, description="UUID for conversation (read only)", example='c321233c-a674-4ab7-8b25-8047a8235ce7'),
        'source': fields.String(enum=['IRC', 'ISS', 'MAIL', 'COMM'],required=True, description="Type of conversation [IRC = IRC Channel, ISS = Issue Tracker, MAIL = Mailing List, COMM = Commit Messages]", example='IRC'),
        'context': fields.Raw(required=True,description = 'Additional information related to conversation as JSON object', example={'server':'someserver.com','channel':'#some_channel'})
        })

conversation_api_model_list = api.model('Conversations List',{
    'conversations': fields.List(fields.Nested(conversation_api_model))
})

@nm_conversation.route('/')
class ConversationControllerSimple(Resource):
    @nm_conversation.expect(conversation_api_model,validate=True)
    @nm_conversation.marshal_with(api.model('Conversation UUID',{'uuid': fields.String(description='The UUID generated by the internal database',example='5903f16e-40d9-4678-b6d5-d4e16402f9e3')}),code=201)
    def post(self):
        # Retrieve request data
        request_json = request.get_json()

        # Create conversation
        Session = sessionmaker(bind=engine)
        session = Session()
        new_conversation = Conversation(**request.get_json())

        session.add(new_conversation)
        session.commit()

        # Build response
        return_json = {
            "uuid": str(new_conversation.id)
        }

        return return_json, 201

    @nm_conversation.marshal_with(conversation_api_model_list,code=200)
    def get(self, conversation_id=None):
        return {"conversations": list(map(lambda x: x.to_dict(), db.session.query(Conversation).order_by('source').all()))}, 200


@nm_conversation.route('/<string:conversation_id>')
class ConversationControllerWithParameter(Resource):
    @nm_conversation.marshal_with(conversation_api_model,code=200)
    def get(self, conversation_id=None):

        result = db.session.query(Conversation).filter_by(
            id=conversation_id).one()

        return result.to_dict(), 200
